// #if !defined(COMPARGS)
// #include "miscelous.h"
// #endif
// #if !defined(STD::CERR)
// #include <iostream>
// #endif

class interaction {
 private:
  domain * input;
  domain * output;
  double range;
  double diff;
  double cons;
  int type;
 public:
  interaction();
  interaction(domain*,domain*);
  void setInput(domain*);
  void setOutput(domain*);
  void setParams(double,double,double);
  void setParams(double,double);
  void setType(int);
  void setType(char*);
  void step (void);
  void step (double);

  int showType(void);

  ~interaction();
 };

interaction::interaction () {
 range=0;
 diff=0;
 cons=0;
 };

interaction::interaction (domain* d1,domain* d2) {
 range=0;
 diff=0;
 cons=0;
 input=d1;
 output=d2;
 };

void interaction::setInput (domain * d) {
 input=d; 
 };

void interaction::setOutput (domain * d) {
 output=d; 
 };

  
void interaction::setParams (double d, double c, double r) {
 cons=c; diff=d; range=r; 
 };

void interaction::setParams (double d, double c) {
 cons=c; diff=d; 
 };

void interaction::setType (int t) {
 type=t; 
 };

void interaction::setType (char *a) {
 if (compargs(a, "none")) type=0;
 else if (compargs(a, "evolve")) type=1;
 else if (compargs(a, "emit")) type=2;
 else if (compargs(a, "transmit")) type=3;
 };
 

void interaction::step (void) {
 switch (type) {
  case 0:
   break;
  case 1: 
   output->evolve(diff,cons);
   break;
  case 2:
   output->emit(diff,cons,range);
  case 3:
//   output->transmit(cons,diff,range);
   std::cerr << "interaction 'transmit' not implemented yet" << std::endl;
   break;
  default:
   std::cerr << "unknown type of interaction" << std::endl;
  };
 };


void interaction::step (double dt) {
 switch (type) {
  case 0:
   break;
  case 1: 
   output->evolve(diff*dt,cons);
   break;
  case 2:
   output->emit(diff*dt,cons,range);
  case 3:
//   output->transmit(cons,diff*dt,range);
   std::cerr << "interaction 'transmit' not implemented yet" << std::endl;
   break;
  default:
  std::cerr << "unknown type of interaction" << std::endl;
  };
 };

int interaction::showType (void) {
 return (type);
 };

 interaction::~interaction () {
  delete [] input;
  delete [] output;
  };
